#!/usr/bin/perl

########################################################################
# Copyright (C) 2016  yoku0825
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
########################################################################


use strict;
use warnings;
use utf8;
use DBI;
use Term::ANSIColor qw/:constants/;

my @suite = qw/spade club heart diamond/;
my @number= 1 .. 13;

my $dsn = "dbi:mysql:world;mysql_socket=/usr/mysql/5.7.16/data/mysql.sock";
my $conn= DBI->connect($dsn, "root", "");

$conn->do("DROP TABLE IF EXISTS card");
$conn->do("CREATE TABLE card (seq int unsigned not null, suite varchar(8) not null, number int unsigned not null)");

print("Import 100 cards.\n");
for (my $n= 1; $n <= 100; $n++)
{
  $conn->do("INSERT INTO card (seq, suite, number) VALUES (?, ?, ?)",
            undef, $n, $suite[rand(4)], $number[rand(13)]);
}

my @buffer;
printf("%s%s### Searching spade one by one.%s\n", BOLD, GREEN, RESET);
foreach my $row (@{$conn->selectall_arrayref("SELECT * FROM card ORDER BY seq", {Slice => {}})})
{
  printf("  %03d: %7s - %d", $row->{seq}, $row->{suite}, $row->{number});

  if ($row->{suite} eq "spade")
  {
    printf("\t%smatched 'spade' !!%s", YELLOW, RESET);
    push(@buffer, $row);
  }
  printf("\n");

  sleep 1 unless $row->{seq} % 30;
}
printf("%s%s### Searching done, thre're %d spade cards.%s\n", BOLD, GREEN, $#buffer + 1, RESET);


printf("%s%s### Sorting cards A to K.%s\n", BOLD, GREEN, RESET);
foreach my $card (@buffer)
{
  printf("  %7s - %d\n", $card->{suite}, $card->{number});
}
sleep 1;
@buffer= sort { $a->{number} <=> $b->{number} }@buffer;
printf("%s%s### Sorting done.%s\n", BOLD, GREEN, RESET);
foreach my $card (@buffer)
{
  printf("  %7s - %d\n", $card->{suite}, $card->{number});
}
sleep 1;

printf("%s%s### Pick top 5 cards.%s\n", BOLD, GREEN, RESET);
for (my $n= 0; $n < 5; $n++)
{
  printf("  %7s - %d\n", $buffer[$n]->{suite}, $buffer[$n]->{number});
 } 
